include:
  - template: 'Workflows/MergeRequest-Pipelines.gitlab-ci.yml'
  - project: unboundsoftware/ci-templates
    file: Release.gitlab-ci.yml

variables:
  UNBOUND_RELEASE_TAG_ONLY: true

stages:
  - test
  - release

test:
  stage: test
  image: amd64/golang:1.24.1@sha256:f4707a73c390cc4ee035f7527f25907c3e06745ab946628f72cb459b2e70d401
  script:
    - go fmt $(go list ./...)
    - go vet $(go list ./...)
    - CGO_ENABLED=1 go test -timeout 1m -mod=readonly -race -coverprofile=coverage.txt -covermode=atomic -coverpkg=$(go list ./... | tr '\n' , | sed 's/,$//') ./...
    - go tool cover -html=coverage.txt -o coverage.html
    - go tool cover -func=coverage.txt
    - curl -Os https://uploader.codecov.io/latest/linux/codecov
    - chmod +x codecov
    - ./codecov -t ${CODECOV_TOKEN}
  artifacts:
    paths:
      - coverage.html
      - coverage.txt

check_release:
  stage: test
  image:
    name: goreleaser/goreleaser:v2.7.0@sha256:41247b711fc423eddcd8395b998b9de5c7d169bfe99e6a474ba35e87896c1343
    entrypoint: [ '' ]
  script: |
    goreleaser check
    goreleaser release --snapshot --clean

release:
  stage: release
  needs:
    - unbound_release_prepare_release
  image:
    name: goreleaser/goreleaser:v2.7.0@sha256:41247b711fc423eddcd8395b998b9de5c7d169bfe99e6a474ba35e87896c1343
    entrypoint: [ '' ]
  variables:
    # Image is set in group variables
    # GORELEASER_IMAGE: goreleaser/goreleaser:v1.21.2-amd64

    # Or, use any registry, including the official one.
    DOCKER_REGISTRY: https://index.docker.io/v1/

    # Disable shallow cloning so that goreleaser can diff between tags to
    # generate a changelog.
    GIT_DEPTH: 0

  # Only run this release job for tags, not every commit (for example).
  rules:
    - if: $CI_COMMIT_TAG

  script: |
    goreleaser release --clean --release-notes=CHANGES.md
